<?php
/*
Plugin Name: Simple Facebook Share Button
Plugin URI: http://www.ethitter.com/plugins/simple-facebook-share-button/
Description: Painlessly add a Facebook® Share button to your posts and/or pages. Supports all five button types, including custom button text, and placement above or below content. Includes compatibility modes to ensure seamless theme integration. Button can also be added using a shortcode or by inserting a function in your template.
Author: Erick Hitter
Version: 1.0.4
Author URI: http://www.ethitter.com/
*/

add_action("plugins_loaded","SFBSB_init");
add_action("wp_head","SFBSB_head");
add_action("admin_init","register_SFBSB_settings");
add_action("admin_menu","SFBSB_menu");
add_filter("contextual_help","SFBSB_help",10,2);
add_shortcode("SFBSB","SFBSB_shortcode");
register_deactivation_hook( __FILE__,"SFBSB_deactivate");
include_once("simple_fb_share_button_options.php");

function SFBSB_head () {echo "<!-- Simple Facebook Share Button; http://www.ethitter.com/plugins/simple-facebook-share-button/ -->\r\n<script src=\"http://static.ak.fbcdn.net/connect.php/js/FB.Loader\" type=\"text/javascript\"></script>\r\n<script src=\"http://static.ak.fbcdn.net/connect.php/js/FB.Share\" type=\"text/javascript\"></script>\r\n";}

function SFBSB_init() {
$display_auto = get_option("SFBSB_display","notset");
if($display_auto=="1") {add_filter("the_content","SFBSB_auto");} elseif ($display_auto=="notset") {update_option("SFBSB_display","0");}

$button = get_option("SFBSB_button","notset"); if($button=="notset") {update_option("SFBSB_button","button");} elseif(empty($button)) {update_option("SFBSB_button","button");}
$placement = get_option("SFBSB_placement","notset"); if($placement=="notset") {update_option("SFBSB_placement","tl");} elseif(empty($placement)) {update_option("SFBSB_placement","tl");}
$content = get_option("SFBSB_content","notset"); if($content=="notset") {update_option("SFBSB_content","post");} elseif(empty($content)) {update_option("SFBSB_content","post");}
}

function register_SFBSB_settings() {
register_setting("SFBSB_settings","SFBSB_button");
register_setting("SFBSB_settings","SFBSB_display");
register_setting("SFBSB_settings","SFBSB_content");
register_setting("SFBSB_settings","SFBSB_placement");
register_setting("SFBSB_settings","SFBSB_style");
register_setting("SFBSB_settings","SFBSB_align");
register_setting("SFBSB_settings","SFBSB_custom_text");
register_setting("SFBSB_settings","SFBSB_tpad");
register_setting("SFBSB_settings","SFBSB_bpad");
register_setting("SFBSB_settings","SFBSB_lpad");
register_setting("SFBSB_settings","SFBSB_rpad");
register_setting("SFBSB_settings","SFBSB_compatibility");
register_setting("SFBSB_settings","SFBSB_uninstall");
}

function SFBSB_deactivate() {
$uninstall = get_option("SFBSB_uninstall");
if ($uninstall=="1") {
delete_option("SFBSB_button");
delete_option("SFBSB_display");
delete_option("SFBSB_content");
delete_option("SFBSB_placement");
delete_option("SFBSB_style");
delete_option("SFBSB_align");
delete_option("SFBSB_custom_text");
delete_option("SFBSB_tpad");
delete_option("SFBSB_bpad");
delete_option("SFBSB_lpad");
delete_option("SFBSB_rpad");
delete_option("SFBSB_compatibility");
delete_option("SFBSB_uninstall");
	}
}

function SFBSB_do() {$msg = "<!-- Simple Facebook Share Button: this function is no longer supported. See the plugin documentation and replace this function with SFBSB_direct(). -->"; return $msg;}

function SFBSB_direct() {
$num_opts = func_num_args(); $opts = func_get_args();
$buttons = array("box_count","button_count","button","icon");
$url = get_permalink();
if ($num_opts=="0") {$button_type = "button";} else {
	if (in_array($opts[0],$buttons)) {$button_type = $opts[0];}
		else {$button_type = "icon_link"; $custom_text = $opts[0];}
	}
$share_button = "<a name=\"fb_share\" type=\"$button_type\" share_url=\"$url\">$custom_text</a>";
return $share_button;
}

function SFBSB_shortcode($atts) {
extract(shortcode_atts(array('button' => 'button','align' => 'notset','style' => 'float:left;','custom_text' => ''),$atts));
if($button=="custom") {$button_type="icon_link";} else {$button_type=$button;}
$url = get_permalink();
$style_do=" style=\"$style\"";
if ($align!="notset") {$align_do = " align=\"$align\"";}
$share_button = "<div$align_do$style_do><a name=\"fb_share\" type=\"$button_type\" share_url=\"$url\">$custom_text</a></div>";
return $share_button;
}

function SFBSB_auto($content) {
$button = get_option("SFBSB_button"); if($button=="custom") {$button_type="icon_link";$custom_text=get_option("SFBSB_custom_text");} else {$button_type=$button;}
$url = get_permalink();
$display_where = get_option("SFBSB_content");
$placement = get_option("SFBSB_placement");
$style = get_option("SFBSB_style");
$compatibility = get_option("SFBSB_compatibility","notset");
$tpad = get_option("SFBSB_tpad","notset"); if($tpad < "0") {unset($tpad);} if (is_numeric($tpad)) {$top = $tpad; $top .= "px";} else {$top = "5px";}
$bpad = get_option("SFBSB_bpad","notset"); if($bpad < "0") {unset($bpad);} if (is_numeric($bpad)) {$bottom = $bpad; $bottom .= "px";} else {$bottom = "5px";}
$lpad = get_option("SFBSB_lpad","notset"); if($lpad < "0") {unset($lpad);} if (is_numeric($lpad)) {$left = $lpad; $left .= "px";} else {$left = "5px";}
$rpad = get_option("SFBSB_rpad","notset"); if($rpad < "0") {unset($rpad);} if (is_numeric($rpad)) {$right = $rpad; $right .= "px";} else {$right = "5px";}

if ($placement=="tl") {
	if (is_numeric($tpad)) {if (is_numeric($lpad)) {$padding = "$top $right $bottom $left";} else {$padding = "$top $right $bottom 0px";}}
		else {if (is_numeric($lpad)) {$padding = "0px $right $bottom $left";} else {$padding = "0px $right $bottom 0px";}}
	}
elseif ($placement=="tr") {
	if (is_numeric($tpad)) {if (is_numeric($rpad)) {$padding = "$top $right $bottom $left";} else {$padding = "$top 0px $bottom $left";}}
		else {if (is_numeric($rpad)) {$padding = "0px $right $bottom $left";} else {$padding = "0px 0px $bottom $left";}}
	}
elseif ($placement=="bl") {
	if (is_numeric($bpad)) {if (is_numeric($lpad)) {$padding = "$top $right $bottom $left";} else {$padding = "$top $right $bottom 0px";}}
		else {if (is_numeric($lpad)) {$padding = "$top $right 0px $left";} else {$padding = "$top $right 0px 0px";}}
	}
elseif ($placement=="br") {
	if (is_numeric($bpad)) {if (is_numeric($rpad)) {$padding = "$top $right $bottom $left";} else {$padding = "$top 0px $bottom $left";}}
		else {if (is_numeric($lpad)) {$padding = "$top $right 0px $left";} else {$padding = "$top 0xp 0px $left";}}
	}
if($placement=="tl" or $placement=="bl") {$align=" align=\"left\"";} elseif ($placement=="tr" or $placement=="br") {$align=" align=\"right\"";}
if($compatibility=="1") {$float = "none";} 
	elseif($compatibility=="2") {
		if($placement=="tl" or $placement=="bl") {$float = "left;clear:right";}
			elseif($placement=="tr" or $placement=="br") {$float = "right;clear:left";}
	}
	elseif($compatibility=="3") {
		if($placement=="tl" or $placement=="bl") {$float = "none;clear:right";}
			elseif($placement=="tr" or $placement=="br") {$float = "none;clear:left";}
	}
	else {
		if($placement=="tl" or $placement=="bl") {$float = "left";}
			elseif($placement=="tr" or $placement=="br") {$float = "right";}
	}
if(!empty($style)) {$style_do=" style=\"$style\"";} else {$style_do=" style=\"float:$float;padding:$padding;\"";}

$fb = "<div$align$style_do><a name=\"fb_share\" type=\"$button_type\" share_url=\"$url\">$custom_text</a></div>";

if ($placement=="tl" or $placement=="tr") {
	if (is_page() && $display_where=="page") {$org = $content;$content = $fb;$content .= $org; return $content;}
	elseif (!is_page() && $display_where=="post") {$org = $content;$content = $fb;$content .= $org; return $content;}
	elseif ($display_where=="both") {$org = $content;$content = $fb;$content .= $org; return $content;}
	else {return $content;}
}
if ($placement=="bl" or $placement=="br") {
	if (is_page() && $display_where=="page") {$content = $content;$content .= $fb; return $content;}
	elseif (!is_page() && $display_where=="post") {$content = $content;$content .= $fb; return $content;}
	elseif ($display_where=="both") {$content = $content;$content .= $fb; return $content;}
	else {return $content;}
	}
}

function SFBSB_menu() {
add_options_page("Simple Facebook Share Button", "Simple FB Share Button", "administrator", "simple_fb_share_button_options", "SFBSB_options");
}

?>